diff options
| author | David M. Syzdek <david@syzdek.net> | 2023-01-16 13:09:40 -0900 |
|---|---|---|
| committer | David M. Syzdek <david@syzdek.net> | 2023-01-16 13:09:40 -0900 |
| commit | bb112b4eca6647104f472f8f8195ba8ee3437809 (patch) | |
| tree | ca26dd5e1ad5cda7122c81b63cfb658a72405bb0 | |
| parent | 07d1f1608918fdc1e7685ccf75fb01208cbfa476 (diff) | |
| download | otputils-bb112b4eca6647104f472f8f8195ba8ee3437809.tar.gz otputils-bb112b4eca6647104f472f8f8195ba8ee3437809.tar.bz2 otputils-bb112b4eca6647104f472f8f8195ba8ee3437809.tar.xz otputils-bb112b4eca6647104f472f8f8195ba8ee3437809.zip | |
libotputil: adding otputil_debug()
| -rw-r--r-- | include/otputil.h | 6 | ||||
| -rw-r--r-- | lib/libotputil/libotputil.sym | 1 | ||||
| -rw-r--r-- | lib/libotputil/lmisc.c | 50 |
3 files changed, 57 insertions, 0 deletions
diff --git a/include/otputil.h b/include/otputil.h index 2d4a774..eae91bc 100644 --- a/include/otputil.h +++ b/include/otputil.h | |||
| @@ -309,6 +309,12 @@ otputil_set_param( | |||
| 309 | //----------------// | 309 | //----------------// |
| 310 | #pragma mark misc functions | 310 | #pragma mark misc functions |
| 311 | 311 | ||
| 312 | _OTPUTIL_F void | ||
| 313 | otputil_debug( | ||
| 314 | otputil_t * tud, | ||
| 315 | FILE * fs ); | ||
| 316 | |||
| 317 | |||
| 312 | _OTPUTIL_F char * | 318 | _OTPUTIL_F char * |
| 313 | otputil_getpass( | 319 | otputil_getpass( |
| 314 | const char * prompt, | 320 | const char * prompt, |
diff --git a/lib/libotputil/libotputil.sym b/lib/libotputil/libotputil.sym index cf898f6..4ad91f4 100644 --- a/lib/libotputil/libotputil.sym +++ b/lib/libotputil/libotputil.sym | |||
| @@ -70,6 +70,7 @@ otputil_initialize | |||
| 70 | otputil_set_param | 70 | otputil_set_param |
| 71 | # | 71 | # |
| 72 | # misc functions | 72 | # misc functions |
| 73 | otputil_debug | ||
| 73 | otputil_err2string | 74 | otputil_err2string |
| 74 | otputil_getpass | 75 | otputil_getpass |
| 75 | otputil_md2str | 76 | otputil_md2str |
diff --git a/lib/libotputil/lmisc.c b/lib/libotputil/lmisc.c index 4b62d1e..67ebd3d 100644 --- a/lib/libotputil/lmisc.c +++ b/lib/libotputil/lmisc.c | |||
| @@ -81,6 +81,56 @@ static const otputil_map_t otputil_md_list[] = | |||
| 81 | ///////////////// | 81 | ///////////////// |
| 82 | #pragma mark - Functions | 82 | #pragma mark - Functions |
| 83 | 83 | ||
| 84 | void | ||
| 85 | otputil_debug( | ||
| 86 | otputil_t * tud, | ||
| 87 | FILE * fs ) | ||
| 88 | { | ||
| 89 | const otputil_bv_t * default_bv; | ||
| 90 | |||
| 91 | default_bv = &otputil_const_defaults_k; | ||
| 92 | tud = ((tud)) ? tud : &otputil_defaults; | ||
| 93 | fs = ((fs)) ? fs : stdout; | ||
| 94 | |||
| 95 | fprintf(fs, "OTPUtils Options:\n"); | ||
| 96 | fprintf(fs, " OTPUTIL_OPT_DESC: %s\n", (((tud->util_desc)) ? tud->util_desc : "n/a")); | ||
| 97 | fprintf(fs, " OTPUTIL_OPT_METHOD: %i\n", tud->util_method); | ||
| 98 | fprintf(fs, "\n"); | ||
| 99 | |||
| 100 | fprintf(fs, "HOTP (RFC 4226) Options:\n"); | ||
| 101 | fprintf(fs, " OTPUTIL_OPT_HOTP_C: %" PRIu64 "\n", tud->hotp_c); | ||
| 102 | fprintf(fs, " OTPUTIL_OPT_HOTP_DIGITS: %i\n", tud->hotp_digits); | ||
| 103 | fprintf(fs, " OTPUTIL_OPT_HOTP_HMAC: %s\n", otputil_md2str(tud->hotp_hmac)); | ||
| 104 | fprintf(fs, " OTPUTIL_OPT_HOTP_KSTR: %s\n", otputil_bvbase32(((tud->hotp_k)) ? tud->hotp_k : default_bv)); | ||
| 105 | fprintf(fs, "\n"); | ||
| 106 | |||
| 107 | fprintf(fs, "OTP (RFC 2289) Options:\n"); | ||
| 108 | fprintf(fs, " OTPUTIL_OPT_OTP_ENCODE: %i\n", tud->otp_encoding); | ||
| 109 | fprintf(fs, " OTPUTIL_OPT_OTP_HASH: %s\n", otputil_md2str(tud->otp_hash)); | ||
| 110 | fprintf(fs, " OTPUTIL_OPT_OTP_PASS: %s\n", (((tud->otp_pass)) ? tud->otp_pass : "n/a")); | ||
| 111 | fprintf(fs, " OTPUTIL_OPT_OTP_SEED: %s\n", (((tud->otp_seed)) ? tud->otp_seed : "n/a")); | ||
| 112 | fprintf(fs, " OTPUTIL_OPT_OTP_SEQ: %i\n", tud->otp_seq); | ||
| 113 | fprintf(fs, "\n"); | ||
| 114 | |||
| 115 | fprintf(fs, "S/KEY (RFC 1760) Options:\n"); | ||
| 116 | fprintf(fs, " OTPUTIL_OPT_SKEY_ENCODE: %i\n", tud->skey_encoding); | ||
| 117 | fprintf(fs, " OTPUTIL_OPT_SKEY_HASH: %s\n", otputil_md2str(tud->skey_hash)); | ||
| 118 | fprintf(fs, " OTPUTIL_OPT_SKEY_PASS: %s\n", (((tud->skey_pass)) ? tud->skey_pass : "n/a")); | ||
| 119 | fprintf(fs, " OTPUTIL_OPT_SKEY_SEQ: %i\n", tud->skey_seq); | ||
| 120 | fprintf(fs, "\n"); | ||
| 121 | |||
| 122 | fprintf(fs, "TOTP (RFC 6238) Options:\n"); | ||
| 123 | fprintf(fs, " OTPUTIL_OPT_TOTP_DIGITS: %i\n", tud->totp_digits); | ||
| 124 | fprintf(fs, " OTPUTIL_OPT_TOTP_HMAC: %s\n", otputil_md2str(tud->totp_hmac)); | ||
| 125 | fprintf(fs, " OTPUTIL_OPT_TOTP_KSTR: %s\n", otputil_bvbase32(((tud->totp_k)) ? tud->totp_k : default_bv)); | ||
| 126 | fprintf(fs, " OTPUTIL_OPT_TOTP_T0: %" PRIu64 "\n", tud->totp_t0); | ||
| 127 | fprintf(fs, " OTPUTIL_OPT_TOTP_TIME: %" PRIu64 "\n", tud->totp_time); | ||
| 128 | fprintf(fs, " OTPUTIL_OPT_TOTP_X: %" PRIu64 "\n", tud->totp_tx); | ||
| 129 | |||
| 130 | return; | ||
| 131 | } | ||
| 132 | |||
| 133 | |||
| 84 | const char * | 134 | const char * |
| 85 | otputil_err2string( | 135 | otputil_err2string( |
| 86 | int err ) | 136 | int err ) |
